"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard")["default"];
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useLoadConfig = exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createSuper"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _utils = require("@lilib/utils");
var LoadStore = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(LoadStore, _EventEmitter);
  var _super = (0, _createSuper2["default"])(LoadStore);
  function LoadStore() {
    var _this;
    (0, _classCallCheck2["default"])(this, LoadStore);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_loadings", new Map());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_reloaders", new Map());
    return _this;
  }
  (0, _createClass2["default"])(LoadStore, [{
    key: "isLoading",
    value: function isLoading(key, loader) {
      if (loader) {
        return this._loadings.get(key) === loader;
      } else {
        return this._loadings.has(key);
      }
    }
  }, {
    key: "setLoading",
    value: function setLoading(key, loader) {
      this._loadings.set(key, loader);
    }
  }, {
    key: "deleteLoading",
    value: function deleteLoading(key, loader) {
      if (loader) {
        if (this._loadings.get(key) === loader) {
          this._loadings["delete"](key);
        }
      } else {
        this._loadings["delete"](key);
      }
    }
  }, {
    key: "getReloaders",
    value: function getReloaders(key) {
      return this._reloaders.get(key) || [];
    }
  }, {
    key: "addReloader",
    value: function addReloader(key, reloader) {
      var reloaders = this._reloaders.get(key);
      if (reloaders) {
        if (!reloaders.includes(reloader)) {
          reloaders.push(reloader);
        }
      } else {
        this._reloaders.set(key, [reloader]);
      }
    }
  }, {
    key: "removeReloader",
    value: function removeReloader(key, reloader) {
      var reloaders = this._reloaders.get(key);
      if (reloaders) {
        var lastIndex = reloaders.lastIndexOf(reloader);
        if (lastIndex >= 0) {
          reloaders.splice(lastIndex, 1);
        }
        if (!reloaders.length) {
          this._reloaders["delete"](key);
        }
      }
    }
  }]);
  return LoadStore;
}(_utils.EventEmitter);
var GLOBAL_LOAD_STORE_ID = "__LILIB_HOOKS_GLOBAL_LOAD_STORE__";
var defaultValue = {
  global: false,
  cacheTime: 5 * 60 * 1000,
  staleTime: 0,
  retry: false,
  retryLimit: 3,
  retryInterval: 0,
  fallbackRetry: false,
  fallbackRetryLimit: 3,
  fallbackRetryInterval: 0,
  polling: false,
  pollingInterval: 30 * 1000,
  pollingInPageHiding: false,
  pollingIntervalInPageHiding: 60 * 1000,
  autoReloadWaitTime: 10 * 1000,
  autoReloadOnPageShow: false,
  autoReloadOnWindowFocus: false,
  autoReloadOnNetworkReconnect: false
};
var LoadContext = /*#__PURE__*/(0, _react.createContext)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, defaultValue), {}, {
  store: new LoadStore()
}));
var useLoadConfig = function useLoadConfig() {
  return (0, _react.useContext)(LoadContext);
};
exports.useLoadConfig = useLoadConfig;
var LoadConfig = function LoadConfig(props) {
  var config = useLoadConfig();
  var storeRef = (0, _react.useRef)();
  var value = (0, _omit["default"])(props, "inherit", "children");
  if (props.inherit) {
    value = (0, _utils.mergeWithDefined)(config, value);
  } else {
    value = (0, _utils.mergeWithDefined)(defaultValue, value);
  }
  if (value.global && _utils.inBrowser && window[GLOBAL_LOAD_STORE_ID]) {
    value.store = window[GLOBAL_LOAD_STORE_ID];
  }
  if (!value.store) {
    if (!storeRef.current) {
      storeRef.current = new LoadStore();
    }
    value.store = storeRef.current;
  }
  if (value.global && _utils.inBrowser && !window[GLOBAL_LOAD_STORE_ID]) {
    window[GLOBAL_LOAD_STORE_ID] = value.store;
  }
  (0, _react.useDebugValue)(value);
  return /*#__PURE__*/_react["default"].createElement(LoadContext.Provider, {
    value: value
  }, props.children);
};
LoadConfig.Context = LoadContext;
LoadConfig.useConfig = useLoadConfig;
var _default = LoadConfig;
exports["default"] = _default;