"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _utils = require("@lilib/utils");
var _useUnmount = _interopRequireDefault(require("../useUnmount"));
function createTargetEffectHook(useHook) {
  return function (effect, deps, targets) {
    var mountedRef = (0, _react.useRef)(false);
    var depsRef = (0, _react.useRef)([]);
    var deps2Ref = (0, _react.useRef)([]);
    var destroyRef = (0, _react.useRef)();
    function destroy() {
      var _destroyRef$current;
      (_destroyRef$current = destroyRef.current) === null || _destroyRef$current === void 0 ? void 0 : _destroyRef$current.call(destroyRef);
    }
    useHook(function () {
      var deps2 = targets.map(_utils.getEffectTarget);
      function create() {
        depsRef.current = deps;
        deps2Ref.current = deps2;
        destroyRef.current = effect();
      }
      if (mountedRef.current) {
        if (!(0, _utils.areArraysEqual)(deps, depsRef.current) || !(0, _utils.areArraysEqual)(deps2, deps2Ref.current)) {
          destroy();
          create();
        }
      } else {
        create();
        mountedRef.current = true;
      }
    });
    (0, _useUnmount["default"])(function () {
      destroy();
      mountedRef.current = false;
    });
  };
}
var _default = createTargetEffectHook;
exports["default"] = _default;