"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _createForOfIteratorHelper2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createForOfIteratorHelper"));
var _utils = require("@lilib/utils");
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
var _useTargetEffect = _interopRequireDefault(require("./useTargetEffect"));
function useClickOutside(target, listener, options) {
  var targets = Array.isArray(target) ? target : [target];
  var _ref = options || {},
    container = _ref.container,
    _ref$eventName = _ref.eventName,
    eventName = _ref$eventName === void 0 ? "mousedown" : _ref$eventName;
  var eventNames = Array.isArray(eventName) ? eventName : [eventName];
  var listenerRef = (0, _useLatestRef["default"])(listener);
  (0, _useTargetEffect["default"])(function () {
    var targetElements = targets.map(_utils.getEffectTarget).filter(Boolean);
    if (!targetElements.length) {
      return;
    }
    function handler(event) {
      var _iterator = (0, _createForOfIteratorHelper2["default"])(targetElements),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var element = _step.value;
          if (element && element.contains(event.target)) {
            return;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      listenerRef.current(event);
    }
    var containerElement = (0, _utils.getEffectTarget)(container) || document;
    var _iterator2 = (0, _createForOfIteratorHelper2["default"])(eventNames),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _eventName2 = _step2.value;
        containerElement.addEventListener(_eventName2, handler);
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return function () {
      var _iterator3 = (0, _createForOfIteratorHelper2["default"])(eventNames),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _eventName = _step3.value;
          containerElement.removeEventListener(_eventName, handler);
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    };
  }, eventNames, targets);
}
var _default = useClickOutside;
exports["default"] = _default;