"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _react = require("react");
var _isFunction = _interopRequireDefault(require("lodash/isFunction"));
var _jsCookie = _interopRequireDefault(require("js-cookie"));
var _useUpdate = _interopRequireDefault(require("./useUpdate"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useInterval3 = _interopRequireDefault(require("./useInterval"));
var _useSafeState3 = _interopRequireDefault(require("./useSafeState"));
function useCookie(name, options) {
  var _ref = options || {},
    defaultValue = _ref.defaultValue,
    _ref$polling = _ref.polling,
    polling = _ref$polling === void 0 ? false : _ref$polling,
    _ref$pollingInterval = _ref.pollingInterval,
    pollingInterval = _ref$pollingInterval === void 0 ? 100 : _ref$pollingInterval,
    validate = _ref.validate;
  function getCookie() {
    var cookie = _jsCookie["default"].get(name);
    if (cookie !== undefined) {
      if (validate) {
        return validate(cookie) ? cookie : defaultValue;
      } else {
        return cookie;
      }
    } else {
      return defaultValue;
    }
  }
  var _useSafeState = (0, _useSafeState3["default"])(getCookie),
    _useSafeState2 = (0, _slicedToArray2["default"])(_useSafeState, 2),
    value = _useSafeState2[0],
    setValue = _useSafeState2[1];
  var setCookie = (0, _usePersist["default"])(function (newValue, attributes) {
    setValue(function (prevValue) {
      newValue = (0, _isFunction["default"])(newValue) ? newValue(prevValue) : newValue;
      if (newValue === undefined) {
        _jsCookie["default"].remove(name, attributes);
        return defaultValue;
      } else {
        _jsCookie["default"].set(name, newValue, attributes);
        return newValue;
      }
    });
  });
  var _useInterval = (0, _useInterval3["default"])(function () {
      var newValue = getCookie();
      if (newValue !== value) {
        setValue(newValue);
      }
    }, pollingInterval),
    _useInterval2 = (0, _slicedToArray2["default"])(_useInterval, 2),
    startPolling = _useInterval2[0],
    cancelPolling = _useInterval2[1];
  (0, _react.useEffect)(function () {
    cancelPolling();
    if (polling) {
      startPolling();
    }
  }, [polling] // eslint-disable-line
  );

  (0, _useUpdate["default"])(function () {
    cancelPolling();
    setValue(getCookie());
    if (polling) {
      startPolling();
    }
  }, [name]);
  (0, _useUpdate["default"])(function () {
    if (_jsCookie["default"].get(name) === undefined && defaultValue !== value) {
      setValue(defaultValue);
    }
  }, [defaultValue]);
  (0, _react.useDebugValue)(value);
  (0, _react.useDebugValue)(name, function (name) {
    return "(raw) " + _jsCookie["default"].get(name);
  });
  return [value, setCookie];
}
var _default = useCookie;
exports["default"] = _default;