"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _isObject = _interopRequireDefault(require("lodash/isObject"));
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
function useDebounce(callback, options) {
  var wait = 0;
  var maxWait = Infinity;
  var leading = false;
  var trailing = true;
  if (typeof options === "number") {
    wait = options;
  } else if ((0, _isObject["default"])(options)) {
    if (options.wait !== undefined) {
      wait = +options.wait;
    }
    if (options.maxWait !== undefined) {
      maxWait = +options.maxWait;
    }
    if (options.leading !== undefined) {
      leading = !!options.leading;
    }
    if (options.trailing !== undefined) {
      trailing = !!options.trailing;
    }
  }
  var callbackRef = (0, _useLatestRef["default"])(callback);
  var debouncedRef = (0, _react.useRef)();
  (0, _react.useMemo)(function () {
    var _debouncedRef$current;
    (_debouncedRef$current = debouncedRef.current) === null || _debouncedRef$current === void 0 ? void 0 : _debouncedRef$current.flush();
    debouncedRef.current = (0, _debounce["default"])(function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      // @ts-ignore
      return callbackRef.current.apply(this, args);
    }, wait, {
      maxWait: maxWait,
      leading: leading,
      trailing: trailing
    });
  }, [wait, maxWait, leading, trailing] // eslint-disable-line
  );

  var debounced = (0, _usePersist["default"])(function () {
    var _debouncedRef$current2;
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    // @ts-ignore
    return (_debouncedRef$current2 = debouncedRef.current) === null || _debouncedRef$current2 === void 0 ? void 0 : _debouncedRef$current2.apply(this, args);
  });
  var flush = (0, _usePersist["default"])(function () {
    var _debouncedRef$current3;
    return (_debouncedRef$current3 = debouncedRef.current) === null || _debouncedRef$current3 === void 0 ? void 0 : _debouncedRef$current3.flush();
  });
  var cancel = (0, _usePersist["default"])(function () {
    var _debouncedRef$current4;
    (_debouncedRef$current4 = debouncedRef.current) === null || _debouncedRef$current4 === void 0 ? void 0 : _debouncedRef$current4.cancel();
  });
  (0, _useUnmount["default"])(cancel);
  return [debounced, {
    flush: flush,
    cancel: cancel
  }];
}
var _default = useDebounce;
exports["default"] = _default;