"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _react = require("react");
var _useUpdate = _interopRequireDefault(require("./useUpdate"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useSafeState3 = _interopRequireDefault(require("./useSafeState"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
var _useDebounce3 = _interopRequireDefault(require("./useDebounce"));
function useDebouncedValue(value, options) {
  var valueRef = (0, _useLatestRef["default"])(value);
  var _useSafeState = (0, _useSafeState3["default"])(value),
    _useSafeState2 = (0, _slicedToArray2["default"])(_useSafeState, 2),
    debouncedValue = _useSafeState2[0],
    setDebouncedValue = _useSafeState2[1];
  var _useDebounce = (0, _useDebounce3["default"])(setDebouncedValue, options),
    _useDebounce2 = (0, _slicedToArray2["default"])(_useDebounce, 2),
    updateDebouncedValue = _useDebounce2[0],
    cancel = _useDebounce2[1].cancel;
  var flush = (0, _usePersist["default"])(function (finalValue) {
    cancel();
    if (arguments.length > 0) {
      setDebouncedValue(finalValue);
    } else {
      setDebouncedValue(valueRef.current);
    }
  });
  (0, _useUpdate["default"])(function () {
    updateDebouncedValue(value);
  }, [value]);
  (0, _react.useDebugValue)(debouncedValue);
  return [debouncedValue, {
    flush: flush,
    cancel: cancel
  }];
}
var _default = useDebouncedValue;
exports["default"] = _default;