"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _react = require("react");
var _isNumber = _interopRequireDefault(require("lodash/isNumber"));
var _isObject = _interopRequireDefault(require("lodash/isObject"));
var _utils = require("@lilib/utils");
var _useUpdate = _interopRequireDefault(require("./useUpdate"));
var _useTimeout3 = _interopRequireDefault(require("./useTimeout"));
var _useSafeState3 = _interopRequireDefault(require("./useSafeState"));
function useDelayedValue(value, options) {
  var delay = 0;
  var include = function include(value) {
    return true;
  };
  var compare = Object.is;
  if ((0, _isNumber["default"])(options)) {
    delay = options;
  } else if ((0, _isObject["default"])(options)) {
    delay = +options.delay;
    if (options.include) {
      include = options.include;
    }
    if (options.compare) {
      compare = options.compare;
    }
  }
  if (process.env.NODE_ENV !== "production") {
    (0, _utils.warning)(!(0, _isNumber["default"])(delay) || !(delay > 0), "You should provide a positive number as the delay time.", {
      scope: "useDelayedValue"
    });
  }
  var _useSafeState = (0, _useSafeState3["default"])(value),
    _useSafeState2 = (0, _slicedToArray2["default"])(_useSafeState, 2),
    state = _useSafeState2[0],
    setState = _useSafeState2[1];
  var _useTimeout = (0, _useTimeout3["default"])(function () {
      return setState(value);
    }, delay),
    _useTimeout2 = (0, _slicedToArray2["default"])(_useTimeout, 2),
    update = _useTimeout2[0],
    cancelUpdate = _useTimeout2[1];
  (0, _useUpdate["default"])(function () {
    if (!compare(value, state)) {
      if (include(value)) {
        update();
      } else {
        setState(value);
      }
    } else {
      cancelUpdate();
    }
  }, [value]);
  (0, _react.useDebugValue)(state);
  return state;
}
var _default = useDelayedValue;
exports["default"] = _default;