"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _react = require("react");
var _utils = require("@lilib/utils");
var _useSafeState3 = _interopRequireDefault(require("./useSafeState"));
var _useResizeObserver = _interopRequireDefault(require("./useResizeObserver"));
function useElementSize(target) {
  var _useSafeState = (0, _useSafeState3["default"])(function () {
      var element = (0, _utils.getEffectTarget)(target);
      if (element) {
        var rect = element.getBoundingClientRect();
        return {
          width: rect.width,
          height: rect.height
        };
      } else {
        return {
          width: undefined,
          height: undefined
        };
      }
    }),
    _useSafeState2 = (0, _slicedToArray2["default"])(_useSafeState, 2),
    _useSafeState2$ = _useSafeState2[0],
    width = _useSafeState2$.width,
    height = _useSafeState2$.height,
    setSize = _useSafeState2[1];
  (0, _useResizeObserver["default"])(target, function (entries) {
    if (entries[0]) {
      var rect = entries[0].target.getBoundingClientRect();
      if (rect.width !== width || rect.height !== height) {
        setSize({
          width: rect.width,
          height: rect.height
        });
      }
    }
  });
  (0, _react.useDebugValue)({
    width: width,
    height: height
  });
  return {
    width: width,
    height: height
  };
}
var _default = useElementSize;
exports["default"] = _default;