"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _isObject = _interopRequireDefault(require("lodash/isObject"));
var _utils = require("@lilib/utils");
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useTargetEffect = _interopRequireDefault(require("./useTargetEffect"));
function useEventListener(target, eventName, listener, options) {
  var capture;
  var once;
  var passive;
  if (typeof options === "boolean") {
    capture = options;
  } else if ((0, _isObject["default"])(options)) {
    if (options.capture !== undefined) {
      capture = !!options.capture;
    }
    if (options.once !== undefined) {
      once = !!options.once;
    }
    if (options.passive !== undefined) {
      passive = !!options.passive;
    }
  }
  var handler = (0, _usePersist["default"])(listener);
  (0, _useTargetEffect["default"])(function () {
    var element = (0, _utils.getEffectTarget)(target);
    if ((0, _utils.isEventTarget)(element)) {
      element.addEventListener(eventName, handler, {
        capture: capture,
        once: once,
        passive: passive
      });
      return function () {
        element.removeEventListener(eventName, handler, {
          capture: capture
        });
      };
    }
  }, [eventName, capture, once, passive], [target]);
}
var _default = useEventListener;
exports["default"] = _default;