"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _utils = require("@lilib/utils");
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _usePreviousRef = _interopRequireDefault(require("./usePreviousRef"));
var mimes = {
  gif: "image/gif",
  png: "image/png",
  ico: "image/x-icon"
};
function getHead() {
  if (_utils.inBrowser) {
    return document.getElementsByTagName("head")[0];
  }
}
function getLink() {
  if (_utils.inBrowser) {
    return document.querySelector("link[rel*='icon']");
  }
}
function useFavicon(href, options) {
  var _ref = options || {},
    mime = _ref.mime,
    restore = _ref.restore;
  var prevHrefRef = (0, _usePreviousRef["default"])(href);
  var oldIconData = (0, _react.useMemo)(function () {
    if (_utils.inBrowser) {
      var link = getLink();
      if (link) {
        return {
          type: link.type,
          rel: link.rel,
          href: link.href
        };
      }
    }
  }, []);
  if (_utils.inBrowser && href != null && href !== prevHrefRef.current) {
    var link = getLink() || document.createElement("link");
    link.href = href;
    link.rel = "shortcut icon";
    link.type = mime || mimes[(0, _utils.getUrlExtname)(href)] || mimes.ico;
    if (!getLink()) {
      var head = getHead();
      head === null || head === void 0 ? void 0 : head.appendChild(link);
    }
  }
  (0, _useUnmount["default"])(function () {
    if (_utils.inBrowser && restore) {
      if (oldIconData === undefined) {
        var _head = getHead();
        var _link = getLink();
        _link && (_head === null || _head === void 0 ? void 0 : _head.removeChild(_link));
      } else {
        var _link2 = getLink();
        if (_link2) {
          _link2.type = oldIconData.type;
          _link2.rel = oldIconData.rel;
          _link2.href = oldIconData.href;
        }
      }
    }
  });
}
var _default = useFavicon;
exports["default"] = _default;