"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("requestidlecallback");
var _react = require("react");
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
function useIdle(callback, options) {
  var timerRef = (0, _react.useRef)();
  var callbackRef = (0, _useLatestRef["default"])(callback);
  var cancel = (0, _usePersist["default"])(function () {
    if (timerRef.current !== undefined) {
      cancelIdleCallback(timerRef.current);
      timerRef.current = undefined;
    }
  });
  var start = (0, _usePersist["default"])(function () {
    cancel();
    timerRef.current = requestIdleCallback(function () {
      callbackRef.current();
    }, options);
  });
  (0, _useUnmount["default"])(cancel);
  return [start, cancel];
}
var _default = useIdle;
exports["default"] = _default;