"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("intersection-observer");
var _utils = require("@lilib/utils");
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useLayoutTargetEffect = _interopRequireDefault(require("./useLayoutTargetEffect"));
function useIntersectionObserver(target, listener, options) {
  var handler = (0, _usePersist["default"])(listener);
  var _ref = options || {},
    root = _ref.root,
    rootMargin = _ref.rootMargin,
    threshold = _ref.threshold;
  (0, _useLayoutTargetEffect["default"])(function () {
    var rootElement = (0, _utils.getEffectTarget)(root);
    var targetElement = (0, _utils.getEffectTarget)(target);
    if (!targetElement) {
      return;
    }
    var observer = new IntersectionObserver(handler, {
      root: rootElement,
      rootMargin: rootMargin,
      threshold: threshold
    });
    observer.observe(targetElement);
    return function () {
      observer.disconnect();
    };
  }, [rootMargin, threshold ? threshold.toString() : "0"], [root, target]);
}
var _default = useIntersectionObserver;
exports["default"] = _default;