"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectSpread2"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectWithoutProperties"));
require("requestidlecallback");
var _react = require("react");
var _isObject = _interopRequireDefault(require("lodash/isObject"));
var _isFunction = _interopRequireDefault(require("lodash/isFunction"));
var _utils = require("@lilib/utils");
var _useUpdate = _interopRequireDefault(require("./useUpdate"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _useSetState3 = _interopRequireDefault(require("./useSetState"));
var _useThrottle3 = _interopRequireDefault(require("./useThrottle"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
var _useMountedRef = _interopRequireDefault(require("./useMountedRef"));
var _useUnmountedRef = _interopRequireDefault(require("./useUnmountedRef"));
var _CacheConfig = require("./configs/CacheConfig");
var _LoadConfig = require("./configs/LoadConfig");
var _excluded = ["store"];
function useLoad(callback) {
  var deps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var _useCacheConfig = (0, _CacheConfig.useCacheConfig)(),
    cache = _useCacheConfig.cache;
  var _useLoadConfig = (0, _LoadConfig.useLoadConfig)(),
    store = _useLoadConfig.store,
    config = (0, _objectWithoutProperties2["default"])(_useLoadConfig, _excluded);
  var _mergeWithDefined = (0, _utils.mergeWithDefined)(config, options),
    key = _mergeWithDefined.key,
    idle = _mergeWithDefined.idle,
    imperative = _mergeWithDefined.imperative,
    independent = _mergeWithDefined.independent,
    fallback = _mergeWithDefined.fallback,
    initialData = _mergeWithDefined.initialData,
    defaultParams = _mergeWithDefined.defaultParams,
    cacheKey = _mergeWithDefined.cacheKey,
    cacheTime = _mergeWithDefined.cacheTime,
    staleTime = _mergeWithDefined.staleTime,
    cacheValidate = _mergeWithDefined.cacheValidate,
    retry = _mergeWithDefined.retry,
    retryLimit = _mergeWithDefined.retryLimit,
    retryInterval = _mergeWithDefined.retryInterval,
    fallbackRetry = _mergeWithDefined.fallbackRetry,
    fallbackRetryLimit = _mergeWithDefined.fallbackRetryLimit,
    fallbackRetryInterval = _mergeWithDefined.fallbackRetryInterval,
    polling = _mergeWithDefined.polling,
    pollingInterval = _mergeWithDefined.pollingInterval,
    pollingInPageHiding = _mergeWithDefined.pollingInPageHiding,
    pollingIntervalInPageHiding = _mergeWithDefined.pollingIntervalInPageHiding,
    autoReloadWaitTime = _mergeWithDefined.autoReloadWaitTime,
    autoReloadOnPageShow = _mergeWithDefined.autoReloadOnPageShow,
    autoReloadOnWindowFocus = _mergeWithDefined.autoReloadOnWindowFocus,
    autoReloadOnNetworkReconnect = _mergeWithDefined.autoReloadOnNetworkReconnect;
  var isAssociated = key != null && !independent;
  var getCachedData = (0, _usePersist["default"])(function () {
    if (cacheKey != null && cache.has(cacheKey)) {
      var cachedData = cache.get(cacheKey);
      if (cacheValidate) {
        return cacheValidate(cachedData) ? cachedData : initialData;
      } else {
        return cachedData;
      }
    } else {
      return initialData;
    }
  });
  var _useSetState = (0, _useSetState3["default"])(function () {
      return {
        data: getCachedData(),
        error: null,
        loading: !imperative
      };
    }),
    _useSetState2 = (0, _slicedToArray2["default"])(_useSetState, 2),
    state = _useSetState2[0],
    setState = _useSetState2[1];
  var mountedRef = (0, _useMountedRef["default"])();
  var unmountedRef = (0, _useUnmountedRef["default"])();
  var callbackRef = (0, _useLatestRef["default"])(callback);
  var fallbackRef = (0, _useLatestRef["default"])(fallback);
  var idRef = (0, _react.useRef)(0);
  var readyRef = (0, _react.useRef)(false);
  var forceRef = (0, _react.useRef)(false);
  var paramsRef = (0, _react.useRef)();
  var loadingRef = (0, _react.useRef)();
  var unlistenRef = (0, _react.useRef)();
  var idleTimerRef = (0, _react.useRef)(0);
  var retryTimerRef = (0, _react.useRef)(0);
  var pollingTimerRef = (0, _react.useRef)(0);
  var clearPending = (0, _usePersist["default"])(function () {
    idRef.current++;
    readyRef.current = false;
    clearTimeout(retryTimerRef.current);
    clearTimeout(pollingTimerRef.current);
    cancelAutoReload();
    cancelIdleCallback(idleTimerRef.current);
    if (loadingRef.current) {
      var _loadingRef$current = loadingRef.current,
        _key = _loadingRef$current.key,
        _store = _loadingRef$current.store;
      if (_store.isLoading(_key, load)) {
        _store.deleteLoading(_key, load);
        _store["for"](_key).emit("cancel");
      }
      loadingRef.current = undefined;
    }
    if (unlistenRef.current) {
      unlistenRef.current();
      unlistenRef.current = undefined;
    }
  });
  var triggerSuccess = (0, _usePersist["default"])(function (data, key) {
    if (options.onSuccess) {
      options.onSuccess(data);
    } else if (config.onSuccess) {
      config.onSuccess(data, key);
    }
    if (config.handleSuccess) {
      config.handleSuccess(data, key);
    }
  });
  var triggerFailure = (0, _usePersist["default"])(function (error, key) {
    if (options.onFailure) {
      options.onFailure(error);
    } else if (config.onFailure) {
      config.onFailure(error, key);
    }
    if (config.handleFailure) {
      config.handleFailure(error, key);
    }
  });
  var triggerFinally = (0, _usePersist["default"])(function (key) {
    if (options.onFinally) {
      options.onFinally();
    } else if (config.onFinally) {
      config.onFinally(key);
    }
    if (config.handleFinally) {
      config.handleFinally(key);
    }
  });
  var load = (0, _usePersist["default"])(function () {
    for (var _len = arguments.length, params = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
      params[_key2] = arguments[_key2];
    }
    clearPending();
    readyRef.current = true;
    paramsRef.current = params;
    var force = forceRef.current;
    if (force) {
      forceRef.current = false;
    }
    if (!mountedRef.current) {
      if (process.env.NODE_ENV !== "production") {
        (0, _utils.warning)(true, "You should not load data before the component is mounted.", {
          scope: "useLoad"
        });
      }
      return new Promise(function () {});
    }
    if (!force && staleTime > 0 && cacheKey != null && cache.has(cacheKey) && state.error == null) {
      var _cachedData;
      var timestamp = cache.getCacheTimestamp(cacheKey);
      if (timestamp && Date.now() - timestamp <= staleTime && (state.data !== undefined || (_cachedData = getCachedData()) !== undefined)) {
        var _data = state.data !== undefined ? state.data : _cachedData;
        if (state.data === undefined) {
          setState({
            data: _cachedData,
            loading: false
          });
        } else if (state.loading) {
          setState({
            loading: false
          });
        }
        return new Promise(function (resolve) {
          resolve(_data);
        });
      }
    }
    if (isAssociated && !store.isLoading(key)) {
      store.setLoading(key, load);
      loadingRef.current = {
        key: key,
        load: load,
        store: store
      };
    }
    var cachedData;
    if (state.data === undefined && cacheKey != null && cache.has(cacheKey) && (cachedData = getCachedData()) !== undefined) {
      setState({
        data: cachedData,
        loading: true
      });
    } else if (!state.loading) {
      setState({
        loading: true
      });
    }
    var id = idRef.current;
    var isCanceled = function isCanceled() {
      return id !== idRef.current;
    };
    var checkPolling = function checkPolling() {
      if (readyRef.current) {
        if ((0, _utils.isPageVisible)()) {
          if (polling) {
            pollingTimerRef.current = +setTimeout(function () {
              if (!isCanceled()) {
                reload();
              }
            }, pollingInterval);
          }
        } else {
          if (pollingInPageHiding) {
            pollingTimerRef.current = +setTimeout(function () {
              if (!isCanceled()) {
                reload();
              }
            }, pollingIntervalInPageHiding);
          }
        }
      }
    };
    if (isAssociated && store.isLoading(key) && !store.isLoading(key, load)) {
      return new Promise(function (resolve, reject) {
        var unlisten = function unlisten() {
          unlistenRef.current = undefined;
          store["for"](key).off("cancel", handleCancel);
          store["for"](key).off("failure", handleReject);
          store["for"](key).off("success", handleResolve);
        };
        var handleCancel = function handleCancel() {
          unlisten();
          if (!isCanceled()) {
            reload();
          }
        };
        var handleResolve = function handleResolve(data) {
          unlisten();
          if (!isCanceled()) {
            resolve(data);
          }
        };
        var handleReject = function handleReject(error) {
          unlisten();
          if (!isCanceled()) {
            reject(error);
          }
        };
        unlistenRef.current = unlisten;
        store["for"](key).on("cancel", handleCancel);
        store["for"](key).on("failure", handleReject);
        store["for"](key).on("success", handleResolve);
      }).then(function (data) {
        if (isCanceled()) {
          return new Promise(function () {});
        }
        triggerSuccess(data, key);
        triggerFinally(key);
        checkPolling();
        return data;
      }, function (error) {
        if (isCanceled()) {
          return new Promise(function () {});
        }
        triggerFailure(error, key);
        triggerFinally(key);
        checkPolling();
        throw error;
      });
    }
    return new Promise(function (resolve, reject) {
      var retryCount = 0;
      var fallbackInvoked = false;
      var fallbackRetryCount = 0;
      var handleReject = function handleReject(error) {
        if (isCanceled()) {
          return;
        }
        if (retry && ++retryCount <= retryLimit) {
          var delay = (0, _isFunction["default"])(retryInterval) ? retryInterval(retryCount) : retryInterval;
          if (delay > 0) {
            retryTimerRef.current = +setTimeout(function () {
              if (!isCanceled()) {
                callbackRef.current.apply(callbackRef, params).then(resolve, handleReject);
              }
            }, delay);
          } else {
            callbackRef.current.apply(callbackRef, params).then(resolve, handleReject);
          }
        } else if (fallbackRef.current && !fallbackInvoked) {
          fallbackInvoked = true;
          fallbackRef.current.apply(fallbackRef, params).then(resolve, handleReject);
        } else if (fallbackRef.current && fallbackInvoked && fallbackRetry && ++fallbackRetryCount <= fallbackRetryLimit) {
          var _delay = (0, _isFunction["default"])(fallbackRetryInterval) ? fallbackRetryInterval(fallbackRetryCount) : fallbackRetryInterval;
          if (_delay > 0) {
            retryTimerRef.current = +setTimeout(function () {
              if (!isCanceled()) {
                if (fallbackRef.current) {
                  fallbackRef.current.apply(fallbackRef, params).then(resolve, handleReject);
                } else {
                  reject(error);
                }
              }
            }, _delay);
          } else {
            fallbackRef.current.apply(fallbackRef, params).then(resolve, handleReject);
          }
        } else {
          reject(error);
        }
      };
      if (idle) {
        idleTimerRef.current = requestIdleCallback(function () {
          if (!isCanceled()) {
            callbackRef.current.apply(callbackRef, params).then(resolve, handleReject);
          }
        }, (0, _isObject["default"])(idle) ? idle : undefined);
      } else {
        callbackRef.current.apply(callbackRef, params).then(resolve, handleReject);
      }
    }).then(function (data) {
      if (isCanceled()) {
        return new Promise(function () {});
      }
      if (cacheKey != null) {
        cache.set(cacheKey, data, {
          cacheTime: cacheTime
        });
      }
      if (isAssociated && store.isLoading(key, load)) {
        store.deleteLoading(key, load);
        store["for"](key).emit("success", data);
        loadingRef.current = undefined;
      }
      setState({
        data: data,
        error: null,
        loading: false
      });
      triggerSuccess(data, key);
      triggerFinally(key);
      checkPolling();
      return data;
    }, function (error) {
      if (isCanceled()) {
        return new Promise(function () {});
      }
      if (isAssociated && store.isLoading(key, load)) {
        store.deleteLoading(key, load);
        store["for"](key).emit("failure", error);
        loadingRef.current = undefined;
      }
      setState({
        error: error,
        loading: false
      });
      triggerFailure(error, key);
      triggerFinally(key);
      checkPolling();
      throw error;
    });
  });
  var force = (0, _usePersist["default"])(function () {
    forceRef.current = true;
    return load.apply(void 0, arguments);
  });
  var reload = (0, _usePersist["default"])(function (options) {
    var params = paramsRef.current || defaultParams;
    if (process.env.NODE_ENV !== "production") {
      (0, _utils.warning)(!!callback.length && params === undefined, "You should provide params by setting `defaultParams` option or calling the `load(...params)` method.", {
        scope: "useLoad"
      });
    }
    forceRef.current = !!options && !!options.force;
    if (params) {
      load.apply(void 0, (0, _toConsumableArray2["default"])(params));
    } else {
      // @ts-ignore
      load();
    }
  });
  var update = (0, _usePersist["default"])(function (newData) {
    setState(function (prevState) {
      return {
        data: (0, _isFunction["default"])(newData) ? newData(prevState.data) : newData
      };
    });
  });
  var cancel = (0, _usePersist["default"])(function () {
    clearPending();
    forceRef.current = false;
    if (!unmountedRef.current && state.loading) {
      setState({
        loading: false
      });
    }
  });
  var _useThrottle = (0, _useThrottle3["default"])(function () {
      if (readyRef.current && !state.loading) {
        reload();
      }
    }, {
      wait: autoReloadWaitTime,
      leading: true,
      trailing: false
    }),
    _useThrottle2 = (0, _slicedToArray2["default"])(_useThrottle, 2),
    autoReload = _useThrottle2[0],
    cancelAutoReload = _useThrottle2[1].cancel;
  (0, _react.useEffect)(function () {
    if (autoReloadOnPageShow || polling || pollingInPageHiding) {
      var listener = function listener() {
        if ((0, _utils.isPageVisible)()) {
          if (autoReloadOnPageShow || polling) {
            autoReload();
          }
        } else {
          if (pollingInPageHiding) {
            autoReload();
          }
        }
      };
      document.addEventListener("visibilitychange", listener);
      return function () {
        document.removeEventListener("visibilitychange", listener);
      };
    }
  }, [autoReloadOnPageShow, polling, pollingInPageHiding, autoReload]);
  (0, _react.useEffect)(function () {
    if (autoReloadOnWindowFocus) {
      window.addEventListener("focus", autoReload);
      return function () {
        window.removeEventListener("focus", autoReload);
      };
    }
  }, [autoReloadOnWindowFocus, autoReload]);
  (0, _react.useEffect)(function () {
    if (autoReloadOnNetworkReconnect) {
      window.addEventListener("online", autoReload);
      return function () {
        window.removeEventListener("online", autoReload);
      };
    }
  }, [autoReloadOnNetworkReconnect, autoReload]);
  (0, _react.useEffect)(function () {
    if (isAssociated) {
      var handleSuccess = function handleSuccess(data) {
        if (!loadingRef.current || loadingRef.current.load !== load) {
          setState({
            data: data,
            error: null,
            loading: false
          });
        }
      };
      var handleFailure = function handleFailure(error) {
        if (!loadingRef.current || loadingRef.current.load !== load) {
          setState({
            error: error,
            loading: false
          });
        }
      };
      store["for"](key).on("success", handleSuccess);
      store["for"](key).on("failure", handleFailure);
      return function () {
        store["for"](key).off("success", handleSuccess);
        store["for"](key).off("failure", handleFailure);
      };
    }
  }, [key, isAssociated, store, load, staleTime, setState]);
  (0, _react.useEffect)(function () {
    if (key != null) {
      store.addReloader(key, reload);
      return function () {
        store.removeReloader(key, reload);
      };
    }
  }, [key, store, reload]);
  (0, _react.useEffect)(function () {
    if (!imperative) {
      reload();
    }
  }, deps // eslint-disable-line
  );

  (0, _useUpdate["default"])(function () {
    if (process.env.NODE_ENV !== "production") {
      (0, _utils.warning)(true, "You should provide an immutable value for the `key` option.", {
        scope: "useLoad"
      });
    }
  }, [key]);
  (0, _useUnmount["default"])(cancel);
  (0, _react.useDebugValue)(state);
  return (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    load: load,
    force: force,
    reload: reload,
    update: update,
    cancel: cancel
  }, state), {}, {
    reloading: state.loading && state.data !== undefined,
    initializing: state.loading && state.data === undefined
  });
}
var _default = useLoad;
exports["default"] = _default;