"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _raf = _interopRequireDefault(require("raf"));
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
function useRaf(callback) {
  var timerRef = (0, _react.useRef)();
  var callbackRef = (0, _useLatestRef["default"])(callback);
  var cancel = (0, _usePersist["default"])(function () {
    if (timerRef.current !== undefined) {
      _raf["default"].cancel(timerRef.current);
      timerRef.current = undefined;
    }
  });
  var start = (0, _usePersist["default"])(function () {
    cancel();
    timerRef.current = (0, _raf["default"])(function () {
      callbackRef.current();
    });
  });
  (0, _useUnmount["default"])(cancel);
  return [start, cancel];
}
var _default = useRaf;
exports["default"] = _default;