"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _resizeObserverPolyfill = _interopRequireDefault(require("resize-observer-polyfill"));
var _utils = require("@lilib/utils");
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useLayoutTargetEffect = _interopRequireDefault(require("./useLayoutTargetEffect"));
function useResizeObserver(target, listener) {
  var handler = (0, _usePersist["default"])(listener);
  (0, _useLayoutTargetEffect["default"])(function () {
    var element = (0, _utils.getEffectTarget)(target);
    if (!element) {
      return;
    }
    var observer = new _resizeObserverPolyfill["default"](handler);
    observer.observe(element);
    return function () {
      observer.disconnect();
    };
  }, [], [target]);
}
var _default = useResizeObserver;
exports["default"] = _default;