"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _react = require("react");
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useUnmountedRef = _interopRequireDefault(require("./useUnmountedRef"));
function useSafeState(initialState) {
  var unmountedRef = (0, _useUnmountedRef["default"])();
  var _useState = (0, _react.useState)(initialState),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    state = _useState2[0],
    setState = _useState2[1];
  var setSafeState = (0, _usePersist["default"])(function (newState) {
    if (unmountedRef.current) {
      return;
    }
    setState(newState);
  });
  return [state, setSafeState];
}
var _default = useSafeState;
exports["default"] = _default;