"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _isObject = _interopRequireDefault(require("lodash/isObject"));
var _throttle = _interopRequireDefault(require("lodash/throttle"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
function useThrottle(callback, options) {
  var wait = 0;
  var leading = false;
  var trailing = true;
  if (typeof options === "number") {
    wait = options;
  } else if ((0, _isObject["default"])(options)) {
    if (options.wait !== undefined) {
      wait = +options.wait;
    }
    if (options.leading !== undefined) {
      leading = !!options.leading;
    }
    if (options.trailing !== undefined) {
      trailing = !!options.trailing;
    }
  }
  var callbackRef = (0, _useLatestRef["default"])(callback);
  var throttledRef = (0, _react.useRef)();
  (0, _react.useMemo)(function () {
    var _throttledRef$current;
    (_throttledRef$current = throttledRef.current) === null || _throttledRef$current === void 0 ? void 0 : _throttledRef$current.flush();
    throttledRef.current = (0, _throttle["default"])(function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      // @ts-ignore
      return callbackRef.current.apply(this, args);
    }, wait, {
      leading: leading,
      trailing: trailing
    });
  }, [wait, leading, trailing] // eslint-disable-line
  );

  var throttled = (0, _usePersist["default"])(function () {
    var _throttledRef$current2;
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    // @ts-ignore
    return (_throttledRef$current2 = throttledRef.current) === null || _throttledRef$current2 === void 0 ? void 0 : _throttledRef$current2.apply(this, args);
  });
  var flush = (0, _usePersist["default"])(function () {
    var _throttledRef$current3;
    return (_throttledRef$current3 = throttledRef.current) === null || _throttledRef$current3 === void 0 ? void 0 : _throttledRef$current3.flush();
  });
  var cancel = (0, _usePersist["default"])(function () {
    var _throttledRef$current4;
    (_throttledRef$current4 = throttledRef.current) === null || _throttledRef$current4 === void 0 ? void 0 : _throttledRef$current4.cancel();
  });
  (0, _useUnmount["default"])(cancel);
  return [throttled, {
    flush: flush,
    cancel: cancel
  }];
}
var _default = useThrottle;
exports["default"] = _default;