"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _react = require("react");
var _useUpdate = _interopRequireDefault(require("./useUpdate"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
var _useSafeState3 = _interopRequireDefault(require("./useSafeState"));
var _useLatestRef = _interopRequireDefault(require("./useLatestRef"));
var _useThrottle3 = _interopRequireDefault(require("./useThrottle"));
function useThrottledValue(value, options) {
  var valueRef = (0, _useLatestRef["default"])(value);
  var _useSafeState = (0, _useSafeState3["default"])(value),
    _useSafeState2 = (0, _slicedToArray2["default"])(_useSafeState, 2),
    throttledValue = _useSafeState2[0],
    setThrottledValue = _useSafeState2[1];
  var _useThrottle = (0, _useThrottle3["default"])(setThrottledValue, options),
    _useThrottle2 = (0, _slicedToArray2["default"])(_useThrottle, 2),
    updateThrottledValue = _useThrottle2[0],
    cancel = _useThrottle2[1].cancel;
  var flush = (0, _usePersist["default"])(function (finalValue) {
    cancel();
    if (arguments.length > 0) {
      setThrottledValue(finalValue);
    } else {
      setThrottledValue(valueRef.current);
    }
  });
  (0, _useUpdate["default"])(function () {
    updateThrottledValue(value);
  }, [value]);
  (0, _react.useDebugValue)(throttledValue);
  return [throttledValue, {
    flush: flush,
    cancel: cancel
  }];
}
var _default = useThrottledValue;
exports["default"] = _default;