"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _useUnmount = _interopRequireDefault(require("./useUnmount"));
var _usePersist = _interopRequireDefault(require("./usePersist"));
function useTimeout(callback, timeout) {
  var handler = (0, _usePersist["default"])(callback);
  var timerRef = (0, _react.useRef)();
  var cancel = (0, _usePersist["default"])(function () {
    if (timerRef.current !== undefined) {
      clearTimeout(timerRef.current);
      timerRef.current = undefined;
    }
  });
  var start = (0, _usePersist["default"])(function () {
    cancel();
    timerRef.current = setTimeout(handler, timeout);
  });
  (0, _useUnmount["default"])(cancel);
  return [start, cancel];
}
var _default = useTimeout;
exports["default"] = _default;