import { useRef } from "react";
import useUnmount from "../useUnmount";
function createUpdateHook(useHook) {
  return function (effect, deps) {
    var mountedRef = useRef(false);
    useHook(function () {
      if (mountedRef.current) {
        return effect();
      } else {
        mountedRef.current = true;
      }
    }, deps);
    useUnmount(function () {
      mountedRef.current = false;
    });
  };
}
export default createUpdateHook;