import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import { useDebugValue } from "react";
import useUpdate from "./useUpdate";
import usePersist from "./usePersist";
import useSafeState from "./useSafeState";
import useLatestRef from "./useLatestRef";
import useDebounce from "./useDebounce";
function useDebouncedValue(value, options) {
  var valueRef = useLatestRef(value);
  var _useSafeState = useSafeState(value),
    _useSafeState2 = _slicedToArray(_useSafeState, 2),
    debouncedValue = _useSafeState2[0],
    setDebouncedValue = _useSafeState2[1];
  var _useDebounce = useDebounce(setDebouncedValue, options),
    _useDebounce2 = _slicedToArray(_useDebounce, 2),
    updateDebouncedValue = _useDebounce2[0],
    cancel = _useDebounce2[1].cancel;
  var flush = usePersist(function (finalValue) {
    cancel();
    if (arguments.length > 0) {
      setDebouncedValue(finalValue);
    } else {
      setDebouncedValue(valueRef.current);
    }
  });
  useUpdate(function () {
    updateDebouncedValue(value);
  }, [value]);
  useDebugValue(debouncedValue);
  return [debouncedValue, {
    flush: flush,
    cancel: cancel
  }];
}
export default useDebouncedValue;