import "requestidlecallback";
import { useRef } from "react";
import usePersist from "./usePersist";
import useUnmount from "./useUnmount";
import useLatestRef from "./useLatestRef";
function useIdle(callback, options) {
  var timerRef = useRef();
  var callbackRef = useLatestRef(callback);
  var cancel = usePersist(function () {
    if (timerRef.current !== undefined) {
      cancelIdleCallback(timerRef.current);
      timerRef.current = undefined;
    }
  });
  var start = usePersist(function () {
    cancel();
    timerRef.current = requestIdleCallback(function () {
      callbackRef.current();
    }, options);
  });
  useUnmount(cancel);
  return [start, cancel];
}
export default useIdle;