import { useRef } from "react";
import useLatestRef from "./useLatestRef";
function usePersist(callback) {
  var resultRef = useRef();
  var callbackRef = useLatestRef(callback);
  if (!resultRef.current) {
    resultRef.current = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return callbackRef.current.apply(this, args);
    };
  }
  return resultRef.current;
}
export default usePersist;