import { useRef } from "react";
import raf from "raf";
import useUnmount from "./useUnmount";
import usePersist from "./usePersist";
import useLatestRef from "./useLatestRef";
function useRaf(callback) {
  var timerRef = useRef();
  var callbackRef = useLatestRef(callback);
  var cancel = usePersist(function () {
    if (timerRef.current !== undefined) {
      raf.cancel(timerRef.current);
      timerRef.current = undefined;
    }
  });
  var start = usePersist(function () {
    cancel();
    timerRef.current = raf(function () {
      callbackRef.current();
    });
  });
  useUnmount(cancel);
  return [start, cancel];
}
export default useRaf;