import React, { FC, ReactNode } from "react";
export interface CacheInterface {
    has(key: any): boolean;
    get(key: any): any;
    getCacheTimestamp(key: any): number | undefined;
    set(key: any, data: any, options?: {
        cacheTime?: number;
    }): any;
    delete(key: any): any;
    isReady(): boolean;
    once(name: "ready", listener: () => void): any;
    off(name: "ready", listener: () => void): any;
    for(key: any): {
        on(name: "set" | "delete", listener: (data: any) => void): any;
        off(name: "set" | "delete", listener: (data: any) => void): any;
    };
}
export interface CacheConfigValue {
    global: boolean;
    cache: CacheInterface;
    cacheTime: number;
    cacheSync: boolean | {
        set?: boolean;
        delete?: boolean;
    };
    fallback?: ReactNode;
}
export interface CacheConfigProps extends Partial<CacheConfigValue> {
    inherit?: boolean;
    children?: ReactNode;
}
declare const CacheContext: React.Context<CacheConfigValue>;
export declare const useCacheConfig: () => CacheConfigValue;
declare const CacheConfig: FC<CacheConfigProps> & {
    Context: typeof CacheContext;
    useConfig: typeof useCacheConfig;
};
export default CacheConfig;
