export interface StorageHookOptions<T> {
    defaultValue?: T;
    polling?: boolean;
    pollingInterval?: number;
    compare?: (x: any, y: any) => boolean;
    validate?: (value: any) => boolean;
    serialize?: (value: T) => string;
    deserialize?: (raw: string) => T;
}
declare function createStorageHook(storage: Storage | null): {
    <T>(key: string, options: StorageHookOptions<T> & {
        defaultValue: T;
    }): readonly [T, (value: T | ((prevValue: T) => T | undefined) | undefined) => void];
    <T_1>(key: string, options?: StorageHookOptions<T_1> | undefined): readonly [T_1 | undefined, (value: T_1 | ((prevValue: T_1 | undefined) => T_1 | undefined) | undefined) => void];
};
export default createStorageHook;
