import { CacheInterface } from "./configs/CacheConfig";
export interface CacheHookOptions<T> {
    defaultValue?: T;
    cache?: CacheInterface;
    cacheTime?: number;
    cacheSync?: boolean | {
        set?: boolean;
        delete?: boolean;
    };
    validate?: (value: any) => boolean;
    onSet?: (value: any) => void;
    onDelete?: (value: any) => void;
}
declare function useCache<T>(key: {}, options: CacheHookOptions<T> & {
    defaultValue: T;
}): readonly [T, (newValue: T | undefined) => void];
declare function useCache<T>(key: {}, options?: CacheHookOptions<T>): readonly [T | undefined, (newValue: T | undefined) => void];
export default useCache;
