import { LoadCallback, LoadData } from "./useLoad";
export interface SubmitHookOptions<Callback, Data> {
    idle?: boolean;
    fallback?: Callback;
    retry?: boolean;
    retryLimit?: number;
    retryInterval?: number | ((count: number) => number);
    fallbackRetry?: boolean;
    fallbackRetryLimit?: number;
    fallbackRetryInterval?: number | ((count: number) => number);
    onSuccess?: (data: Data) => void;
    onFailure?: (error: any) => void;
    onFinally?: () => void;
}
declare function useSubmit<Callback extends LoadCallback>(callback: Callback, options?: SubmitHookOptions<Callback, LoadData<Callback>>): {
    readonly submit: (...params: Parameters<Callback>) => ReturnType<Callback>;
    readonly submitting: boolean;
};
export default useSubmit;
